#!/usr/bin/env node
var WebSocketClient = require('websocket').client;

var client = new WebSocketClient();

client.on('connectFailed', function(error) {
	console.log('Connect Error: ' + error.toString());
});

client.on('connect', function(connection) {
	console.log('Connected');
	connection.on('error', function(error) {
		console.log("Connection Error: " + error.toString());
	});
	connection.on('close', function() {
		console.log('echo-protocol Connection Closed');
	});
	connection.on('message', function(message) {
		var data = JSON.parse(message.utf8Data);
		var alive = false;
		data.scores.forEach(function(score){
			if(score.playerNum == data.playerNum)
			{
				alive = true;
			}
		});
		if(!alive)
		{
			console.log("Died");
			process.exit();
		}
		var moves = ['NONE','LEFT','UP','RIGHT','DOWN'];
		var move = {
			"move": "NONE",
			"name": "BOT"
		};
		move.move = moves[Math.floor(Math.random()*moves.length)];
		connection.sendUTF(JSON.stringify(move));
	});
});

client.connect('ws://uwcs.co.uk:8037/');
