var gridMade = false;

function initGrid(gridData, playerNum)
{
	var table = $('<table></table>').addClass('grid-main');
	$.each(gridData, function(rowIndex, rowData){
		var row = $('<tr></tr>').addClass('grid-row');
		$.each(rowData, function(colIndex, cellData){
			var cell = $('<td></td>').addClass('grid-cell').addClass('text-center');
			cell.css('background-color', getrgb(cellData));
			row.append(cell);
		});
		table.append(row);
	});
	$('#game-container').html(table);
	var playerColor = $('<div></div>');
	playerColor.text('This is your colour!');
	playerColor.addClass('player-color');
	playerColor.css('background-color', getrgb(playerNum));
	$('#game-container').append(playerColor);
}

function updateGrid(gridData)
{
	var table = $('.grid-main')[0];
	for(y=0; y<gridData.length; y++)
	{
		for(x=0; x<gridData[y].length; x++)
		{
			var cell = $(table.rows[y].cells[x]);
			var cellData = gridData[y][x];
			cell.css('background-color', getrgb(cellData));
		}
	}
}

function setScores(scoreData)
{
	scoreData.reverse();
	$('#score-table').empty();
	var heading = $('<li></li>');
	heading.append($('<h2>Scores</h2>'));
	$('#score-table').append(heading);
	$.each(scoreData, function(index, item){
		var listItem = $('<li></li>').addClass('sidebar-brand');
		if(typeof item.name != 'undefined')
		{
			listItem.html(item.name + ": " + item.score).text();
		}
		else
		{
			listItem.text('Player ' + item.playerNum + ": " + item.score);
		}
		listItem.css('background-color', getrgb(item.playerNum));
		$('#score-table').append(listItem);
	});
}

$('#join-game').on('click', function(){
	var name = $('#name').val();
	//set up websocket
	var ws = new WebSocket('ws://uwcs.co.uk:8037');
	$('#log').hide();
	ws.onopen = function(e){
		$('#log').append('Connected to: ' + e.currentTarget.URL + '<br />');
		var move = {
			"move": "NONE",
		};
		if(name != '')
		{
			move.name = name;
		}
		ws.send(JSON.stringify(move));
	};
	ws.onerror = function(e){
		$('#log').append('Error: ' + e + '<br />');
	};
	ws.onerror = function(e){
		$('#log').append('Connection to server closed<br />');
	};
	ws.onmessage = function(e){
		var data = JSON.parse(e.data);
		$('#log').append('Received: ' + e.data + '<br />');
		if(!gridMade)
		{
			initGrid(data.data, data.playerNum);
			gridMade = true;
		}
		else
		{
			updateGrid(data.data);
		}
		setScores(data.scores);
		
	};
	$(window).on('keydown', function(e){
		if(e.keyCode >= 37 && e.keyCode <=40)
		{
			var move = {
				"move": "NONE",
			};
			if(name != '')
			{
				move.name = name;
			}
			switch(e.keyCode)
			{
				case 37: //left
					move.move = 'LEFT';
					break;
				case 38: //up
					move.move = 'UP';
					break;
				case 39: //right
					move.move = 'RIGHT';
					break;
				case 40: //down
					move.move = 'DOWN';
					break;
			}
			ws.send(JSON.stringify(move));
			e.preventDefault();
			return false;
		}
		return true;
	});
});

function getrgb(playerNum)
{
	return 'rgb('+ (105*playerNum)%256 + ', ' +(58*playerNum)%256 + ', ' + (159*playerNum)%256 +')';
}
